/**
 * Glossary:
 *
 * Level Prefixes:
 * CO: Corneria
 * ME: Meteo
 * SX: Sector X
 * SY: Sector Y
 * SZ: Sector Z
 * KA: Katina
 * AQ: Aquas
 * A6: Area 6
 * FO: Fortuna
 * SO: Solar
 * MA: Macbeth
 * TI: Titania
 * BO: Bolse
 * ZO: Zoness
 * VE1: Venom 1
 * VE2: Venom 2
 * AND: Venom Andross
 */

#include "global.h"

#include "assets/ast_versus.h"
#include "assets/ast_arwing.h"
#include "assets/ast_corneria.h"
#include "assets/ast_meteo.h"
#include "assets/ast_bolse.h"
#include "assets/ast_training.h"
#include "assets/ast_sector_x.h"
#include "assets/ast_sector_y.h"
#include "assets/ast_sector_z.h"
#include "assets/ast_aquas.h"
#include "assets/ast_macbeth.h"
#include "assets/ast_venom_1.h"
#include "assets/ast_venom_2.h"
#include "assets/ast_titania.h"
#include "assets/ast_katina.h"
#include "assets/ast_fortuna.h"
#include "assets/ast_7_ti_1.h"
#include "assets/ast_andross.h"
#include "assets/ast_ve1_boss.h"
#include "assets/ast_area_6.h"
#include "assets/ast_zoness.h"

f32 gZoEnergyBallHitbox[] = {
    1.0f, 0.0f, 50.0f, 0.0f, 25.0f, 0.0f, 25.0f,
};
f32 gCubeHitbox100[] = {
    1.0f, 0.0f, 50.0f, 0.0f, 50.0f, 0.0f, 50.0f,
};
f32 gCubeHitbox150[] = {
    1.0f, 0.0f, 75.0f, 0.0f, 75.0f, 0.0f, 75.0f,
};
f32 gCubeHitbox200[] = {
    1.0f, 0.0f, 100.0f, 0.0f, 100.0f, 0.0f, 100.0f,
};
f32 gCubeHitbox300[] = {
    // unused
    1.0f, 0.0f, 150.0f, 0.0f, 150.0f, 0.0f, 150.0f,
};
f32 gCubeHitbox400[] = {
    1.0f, 0.0f, 200.0f, 0.0f, 200.0f, 0.0f, 200.0f,
};
f32 gItemRingCheckHitbox[] = {
    1.0f, -113.0f, 61.0f, 98.0f, 100.0f, 0.0f, 219.0f,
};
f32 gNoHitbox[] = {
    0.0f,
};
f32 gItemCheckpointHitbox[] = {
    1.0f, -40.0f, 40.0f, 0.0f, 180.0f, 0.0f, 180.0f,
};
f32 gItemSupplyRingHitbox[] = {
    1.0f, 0.0f, 120.0f, 0.0f, 120.0f, 0.0f, 120.0f,
};
f32 gMeteoWarpHitbox[] = {
    1.0f, -40.0f, 100.0f, 0.0f, 100.0f, 0.0f, 100.0f,
};
f32 gItemPathChangeHitbox[] = {
    1.0f, 0.0f, 100.0f, 0.0f, 1200.0f, 0.0f, 1200.0f,
};
f32 gItemLasersHitbox[] = {
    1.0f, 0.0f, 120.0f, 0.0f, 120.0f, 0.0f, 120.0f, 0.0f,
};
f32 gItemBombHitbox[] = {
    1.0f, 0.0f, 120.0f, 0.0f, 120.0f, 0.0f, 120.0f,
};
f32 gActorMissileSeekHitbox[] = {
    1.0f, 0.0f, 40.0f, 0.0f, 40.0f, 0.0f, 40.0f,
};
f32 gMeMoraHitbox[] = {
    1.0f, 0.0f, 50.0f, 0.0f, 50.0f, 0.0f, 50.0f,
};
f32 gTeamHitbox[] = {
    1.0f, 0.0f, 40.0f, 0.0f, 40.0f, 0.0f, 40.0f,
};
f32 gActorAllRangeHItbox[] = {
    1.0f, 0.0f, 40.0f, 0.0f, 40.0f, 0.0f, 40.0f,
};
f32 aWzMeteor1Hitbox[] = {
    1.0f, 0.0f, 140.0f, 0.0f, 170.0f, 0.0f, 140.0f,
};
f32 aWzGateHitbox[] = {
    4.0f, 0.0f,   140.0f, -675.0f, 140.0f, 0.0f,   810.0f, 0.0f,   140.0f, 675.0f, 140.0f,  0.0f,   810.0f,
    0.0f, 140.0f, 0.0f,   810.0f,  675.0f, 140.0f, 0.0f,   140.0f, 0.0f,   810.0f, -675.0f, 140.0f,
};
f32 aWzPillar1Hitbox[] = {
    1.0f, 0.0f, 140.0f, 0.0f, 140.0f, 0.0f, 1800.0f,
};
f32 aWzPillar2Hitbox[] = {
    2.0f, 0.0f, 140.0f, 0.0f, 140.0f, 0.0f, 1800.0f, 1.0f, 141.0f, 1.0f, 1800.0f, 1.0f, 140.0f,
};

// clang-format off
ObjectInfo gObjectInfo[] = {
  /* OBJ_SCENERY_CO_STONE_ARCH */  {(void*)     aCoStoneArchDL, 0, (ObjectFunc)          NULL,        aCoStoneArchHitbox,   800.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_BUMP_1 */  {(void*)     aCoBump1DL, 0, (ObjectFunc)          NULL,       gNoHitbox,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_BUMP_2 */  {(void*)     aCoBump2DL, 0, (ObjectFunc)          NULL,       gNoHitbox,  3000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_BUMP_3 */  {(void*)     aCoBump3DL, 0, (ObjectFunc)          NULL,       gNoHitbox,  3000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_BUMP_4 */  {(void*)     aCoBump4DL, 0, (ObjectFunc)          NULL,       gNoHitbox,  3000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_BUMP_5 */  {(void*)     aCoBump5DL, 0, (ObjectFunc)          NULL,       gNoHitbox,  3000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_HIGHWAY_1 */  {(void*)     aCoHighway1DL, 0, (ObjectFunc)          NULL,        aCoHighway1Hitbox,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_HIGHWAY_2 */  {(void*)     aCoHighway2DL, 0, (ObjectFunc)          NULL,        aCoHighway2Hitbox,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_HIGHWAY_3 */  {(void*)     aCoHighway3DL, 0, (ObjectFunc)          NULL,       gNoHitbox,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_HIGHWAY_4 */  {(void*)     aCoHighway4DL, 0, (ObjectFunc)          NULL,       gNoHitbox,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_BUILDING_1 */  {(void*)     aCoBuilding1DL, 0, (ObjectFunc)          NULL,        aCoBuilding1Hitbox,   200.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_BUILDING_2 */  {(void*)     aCoBuilding2DL, 0, (ObjectFunc)          NULL,        aCoBuilding2Hitbox,   200.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_BUILDING_3 */  {(void*)     aCoBuilding3DL, 0, (ObjectFunc)          NULL,        aCoBuilding3Hitbox,   500.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_BUILDING_4 */  {(void*)     aCoBuilding4DL, 0, (ObjectFunc)          NULL,        aCoBuilding4Hitbox,   200.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_BUILDING_5 */  {(void*)     aCoBuilding5DL, 0, (ObjectFunc) SceneryRotateTowardsCamera,        aCoBuilding5Hitbox,   200.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_BUILDING_6 */  {(void*)     aCoBuilding6DL, 0, (ObjectFunc) SceneryRotateTowardsCamera,        aCoBuilding6Hitbox,   200.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_BUILDING_7 */  {(void*)     aCoBuilding7DL, 0, (ObjectFunc) SceneryRotateTowardsCamera,        aCoBuilding7Hitbox,   200.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_BUILDING_8 */  {(void*)     aCoBuilding8DL, 0, (ObjectFunc) SceneryRotateTowardsCamera,        aCoBuilding8Hitbox,   200.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_BUILDING_ON_FIRE,  */  {(void*) Corneria_CoBuildingOnFire_Draw, 1, (ObjectFunc) Corneria_CoBuildingOnFire_Update,     aCoBuildingOnFireHitbox,   200.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_TOWER,  */  {(void*)     aCoTowerDL, 0, (ObjectFunc)          NULL,        aCoTowerHitbox,   100.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_ARCH_1,  */  {(void*)     aCoArch1DL, 0, (ObjectFunc)          NULL,        aCoArch1Hitbox,   500.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_ARCH_2,  */  {(void*)     aCoArch2DL, 0, (ObjectFunc)          NULL,        aCoArch2Hitbox,   400.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_ARCH_3,  */  {(void*)     aCoArch3DL, 0, (ObjectFunc)          NULL,        aCoArch3Hitbox,   400.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_RADAR_DISH,  */  {(void*)     aRadarDL, 0,    (ObjectFunc)          NULL,        aCoRadarHitbox,   200.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_HIGHWAY_5,  */  {(void*)     aCoHighway5DL, 0, (ObjectFunc)          NULL,        aCoHighway5Hitbox,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_HIGHWAY_6,  */  {(void*)     aCoHighway6DL, 0, (ObjectFunc)          NULL,        aCoHighway6Hitbox,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_HIGHWAY_7,  */  {(void*)     aCoHighway7DL, 0, (ObjectFunc)          NULL,        aCoHighway7Hitbox,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_HIGHWAY_8,  */  {(void*)     aCoHighway8DL, 0, (ObjectFunc)          NULL,        aCoHighway8Hitbox,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_HIGHWAY_9,  */  {(void*)     aCoHighway9DL, 0, (ObjectFunc)          NULL,        aCoHighway9Hitbox,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_TI_SKULL,  */  {(void*) Scenery_DrawTitaniaBones, 1, (ObjectFunc) Scenery_UpdateTitaniaBones, aTiSkullHitbox,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_TI_RIB_0,  */  {(void*) Scenery_DrawTitaniaBones, 1, (ObjectFunc) Scenery_UpdateTitaniaBones, aTiRib0Hitbox, 100.0f, 0, 0, 40, 0, 0.0f, 0 },
  /* OBJ_SCENERY_TI_RIB_1,  */  {(void*) Scenery_DrawTitaniaBones, 1, (ObjectFunc) Scenery_UpdateTitaniaBones, aTiRib1Hitbox, 100.0f, 0, 0, 40, 0, 0.0f, 0 },
  /* OBJ_SCENERY_TI_RIB_2,  */  {(void*) Scenery_DrawTitaniaBones, 1, (ObjectFunc) Scenery_UpdateTitaniaBones, aTiRib2Hitbox, 100.0f, 0, 0, 40, 0, 0.0f, 0 },
  /* OBJ_SCENERY_TI_RIB_3,  */  {(void*) Scenery_DrawTitaniaBones, 1, (ObjectFunc) Scenery_UpdateTitaniaBones, aTiRib3Hitbox, 100.0f, 0, 0, 40, 0, 0.0f, 0 },
  /* OBJ_SCENERY_TI_RIB_4,  */  {(void*) Scenery_DrawTitaniaBones, 1, (ObjectFunc) Scenery_UpdateTitaniaBones, aTiRib4Hitbox, 100.0f, 0, 0, 40, 0, 0.0f, 0 },
  /* OBJ_SCENERY_TI_RIB_5,  */  {(void*) Scenery_DrawTitaniaBones, 1, (ObjectFunc) Scenery_UpdateTitaniaBones, aTiRib5Hitbox, 100.0f, 0, 0, 40, 0, 0.0f, 0 },
  /* OBJ_SCENERY_TI_RIB_6,  */  {(void*) Scenery_DrawTitaniaBones, 1, (ObjectFunc) Scenery_UpdateTitaniaBones, aTiRib6Hitbox, 100.0f, 0, 0, 40, 0, 0.0f, 0 },
  /* OBJ_SCENERY_TI_RIB_7,  */  {(void*) Scenery_DrawTitaniaBones, 1, (ObjectFunc) Scenery_UpdateTitaniaBones, aTiRib7Hitbox, 100.0f, 0, 0, 40, 0, 0.0f, 0 },
  /* OBJ_SCENERY_TI_RIB_8,  */  {(void*) Scenery_DrawTitaniaBones, 1, (ObjectFunc) Scenery_UpdateTitaniaBones, aTiRib8Hitbox, 100.0f, 0, 0, 40, 0, 0.0f, 0 },
  /* OBJ_SCENERY_ME_TUNNEL,  */  {(void*) MeteoTunnel_Draw, 1, (ObjectFunc) MeteoTunnel_Update,       gNoHitbox,  6000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_BUILDING_9,  */  {(void*) CoBuilding9_Draw, 1, (ObjectFunc) CoBuilding9_Update,        aCoBuilding9Hitbox,  1000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_BUILDING_10,  */  {(void*) CoBuilding10_Draw, 1, (ObjectFunc) SceneryRotateTowardsCamera,        aCoBuilding10Hitbox,   300.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_IBEAM,  */  {(void*) CoIBeam_Draw, 1, (ObjectFunc) CoIBeam_Update,        aCoIBeamHitbox,  1000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_ZO_ROCK,  */  {(void*)     aZoRockDL, 0, (ObjectFunc)          NULL,        aZoRockHitbox,   200.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_ZO_OIL_RIG_1,  */  {(void*)     aZoOilRig1DL, 0, (ObjectFunc)          NULL,        aZoOilRig1Hitbox,  1500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_ZO_OIL_RIG_2,  */  {(void*)     aZoOilRig2DL, 0, (ObjectFunc)          NULL,        aZoOilRig2Hitbox,  1500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_ZO_OIL_RIG_3,  */  {(void*)     aZoOilRig3DL, 0, (ObjectFunc)          NULL,        aZoOilRig3Hitbox,  1500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_ZO_ISLAND,  */  {(void*)     aZoIslandDL, 0, (ObjectFunc)          NULL,        aZoIslandHitbox,   500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_VE1_WALL_1,  */  {(void*) Ve1Wall1_Draw, 1, (ObjectFunc)          NULL,        Ve1Wall1Hitbox,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_VE1_WALL_2,  */  {(void*) Ve1Wall2_Draw, 1, (ObjectFunc)          NULL,        aVe1Wall2Hitbox,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_VE1_WALL_3,  */  {(void*)     aVe1SceneryWall3DL, 0, (ObjectFunc)          NULL,        aVe1SceneryWall3Hitbox,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_VE1_HALLWAY_OBSTACLE,  */  {(void*)     aVe1HallwayObstacleDL, 0, (ObjectFunc)          NULL,        aVe1HallwayObstacleHitbox,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_VE1_GENERATOR,  */  {(void*)     aVe1GeneratorDL, 0, (ObjectFunc) Venom1_Ve1Generator_Update,        aVe1GeneratorHitbox,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_VE1_WATCH_POST,  */  {(void*)     aVe1WatchPostDL, 0, (ObjectFunc)          NULL,        aVe1WatchPostHitbox,  2500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_WATERFALL,  */  {(void*)     aCoWaterfallDL, 0, (ObjectFunc) CoWaterfall_Update,        aCoWaterfallHitbox,  1000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_ROCKWALL,  */  {(void*)     aCoRockwallDL, 0, (ObjectFunc)          NULL,        aCoRockwallHitbox,  1000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_CO_DOORS,  */  {(void*) Corneria_CoDoors_Draw, 2, (ObjectFunc) Corneria_CoDoors_Update,        aCoDoorsHitbox,  1000.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_TI_PILLAR,  */  {(void*) Titania_TiPillar_Draw, 1, (ObjectFunc) Titania_TiPillar_Update,        aTiPillarHitbox,   800.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_TI_BRIDGE,  */  {(void*)     aTiBridgeDL, 0, (ObjectFunc)          NULL,        aTiBridgeHitbox,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_BUILDING_1,  */  {(void*)     aMaBuilding1DL, 0, (ObjectFunc)          NULL,        aMaBuilding1Hitbox,   300.0f,  0, 0,  5, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_BUILDING_2,  */  {(void*)     aMaBuilding2DL, 0, (ObjectFunc)          NULL,        aMaBuilding2Hitbox,   400.0f,  0, 0,  5, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_TOWER,  */  {(void*) Macbeth_MaTower_Draw, 1, (ObjectFunc)          NULL,        aMaTowerHitbox,   200.0f,  0, 0,  5, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_WALL_1,  */  {(void*)     aMaWall1DL, 0, (ObjectFunc)          NULL,       gNoHitbox,  1500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_GUILLOTINE_HOUSING,  */  {(void*)     aMaGuillotineHousingDL, 0, (ObjectFunc)          NULL,        aMaGuillotineHousingHitbox,   500.0f,  0, 0,  5, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_GUILLOTINE,  */  {(void*)     aMaGuillotine1DL, 0, (ObjectFunc)          NULL,        aMaGuillotineHitbox,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_PROXIMITY_LIGHT,  */  {(void*) Macbeth_MaProximityLight_Draw, 1, (ObjectFunc)          NULL,        aMaProximityLightHitbox,   400.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_WALL_2,  */  {(void*)     aMaWall2DL, 0, (ObjectFunc)          NULL,        aMaWall2Hitbox,  2500.0f,  0, 0,  5, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_WALL_3,  */  {(void*)     aMaWall3DL, 0, (ObjectFunc)          NULL,        aMaWall3Hitbox,  2000.0f,  0, 0,  5, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_WALL_4,  */  {(void*)     aMaWall4DL, 0, (ObjectFunc)          NULL,        aMaWall4Hitbox,  2500.0f,  0, 0,  5, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_TERRAIN_BUMP,  */  {(void*)     aMaTerrainBumpDL, 0, (ObjectFunc)          NULL,        aMaTerrainBumpHitbox,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_FLOOR_1,  */  {(void*)     aMaFloor1DL, 0, (ObjectFunc)          NULL,        aMaFloor1Hitbox,  1900.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_FLOOR_2,  */  {(void*)     aMaFloor2DL, 0, (ObjectFunc)          NULL,        aMaFloor2Hitbox,  1900.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_FLOOR_3,  */  {(void*)     aMaFloor3DL, 0, (ObjectFunc)          NULL,        aMaFloor3Hitbox,  1100.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_FLOOR_4,  */  {(void*)     aMaFloor4DL, 0, (ObjectFunc)          NULL,        aMaFloor4Hitbox,  1100.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_FLOOR_5,  */  {(void*)     aMaFloor5DL, 0, (ObjectFunc)          NULL,        aMaFloor5Hitbox,  1000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_FLOOR_6,  */  {(void*)     aMaFloor6DL, 0, (ObjectFunc)          NULL,        aMaFloor6Hitbox,  3000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_WEAPONS_FACTORY,  */  {(void*)     aMaWeaponsFactoryDL, 0, (ObjectFunc)          NULL,       gNoHitbox,  1000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_INDICATOR_SIGN,  */  {(void*) Macbeth_IndicatorSign_Draw, 1, (ObjectFunc)          NULL,        aMaIndicatorSignHitbox,   200.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_DISTANCE_SIGN_1,  */  {(void*) Macbeth_IndicatorSign_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,   200.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_DISTANCE_SIGN_2,  */  {(void*) Macbeth_IndicatorSign_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,   200.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_DISTANCE_SIGN_3,  */  {(void*) Macbeth_IndicatorSign_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,   200.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_DISTANCE_SIGN_4,  */  {(void*) Macbeth_IndicatorSign_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,   200.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_DISTANCE_SIGN_5,  */  {(void*) Macbeth_IndicatorSign_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,   200.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_TRAIN_STOP_BLOCK,  */  {(void*) Macbeth_MaTrainStopBlock_Draw, 1, (ObjectFunc) Macbeth_MaTrainStopBlock_Update,       gNoHitbox, 15000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_RAILROAD_SWITCH_1,  */  {(void*) Macbeth_IndicatorSign_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_RAILROAD_SWITCH_2,  */  {(void*) Macbeth_IndicatorSign_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_RAILROAD_SWITCH_3,  */  {(void*) Macbeth_IndicatorSign_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_RAILROAD_SWITCH_4,  */  {(void*) Macbeth_IndicatorSign_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_RAILROAD_SWITCH_5,  */  {(void*) Macbeth_IndicatorSign_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_RAILROAD_SWITCH_6,  */  {(void*) Macbeth_IndicatorSign_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_RAILROAD_SWITCH_7,  */  {(void*) Macbeth_IndicatorSign_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_RAILROAD_SWITCH_8,  */  {(void*) Macbeth_IndicatorSign_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_TRAIN_TRACK_1,  */  {(void*) Macbeth_TrainTrack_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_TRAIN_TRACK_2,  */  {(void*) Macbeth_TrainTrack_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_TRAIN_TRACK_3,  */  {(void*) Macbeth_TrainTrack_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox, 15000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_TRAIN_TRACK_4,  */  {(void*) Macbeth_TrainTrack_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox, 15000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_TRAIN_TRACK_5,  */  {(void*) Macbeth_TrainTrack_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,  2500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_TRAIN_TRACK_6,  */  {(void*) Macbeth_TrainTrack_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox, 15000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_TRAIN_TRACK_7,  */  {(void*) Macbeth_TrainTrack_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox, 15000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_TRAIN_TRACK_8,  */  {(void*) Macbeth_TrainTrack_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,  2500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_TRAIN_TRACK_9  */  {(void*) Macbeth_TrainTrack_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,  2500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_TRAIN_TRACK_10  */  {(void*) Macbeth_TrainTrack_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,  2500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_TRAIN_TRACK_11  */  {(void*) Macbeth_TrainTrack_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,  2500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_TRAIN_TRACK_12  */  {(void*) Macbeth_TrainTrack_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,  2500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_SWITCH_TRACK  */  {(void*) Macbeth_TrainTrack_Draw, 1, (ObjectFunc) Macbeth_MaSwitchTrack_Update,        aMaSwitchTrackHitbox,  2500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_MA_TRAIN_TRACK_13  */  {(void*) Macbeth_TrainTrack_Draw, 1, (ObjectFunc)          NULL,        aMaTrainTrack13Hitbox,  1300.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_SY_SHIP_1  */  {(void*)     aSyShip1DL, 0, (ObjectFunc)          NULL,        aSyShip1Hitbox,  4000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_SY_SHIP_2  */  {(void*)     aSyShip2DL, 0, (ObjectFunc)          NULL,        aSyShip2Hitbox,  4000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_SY_SHIP_3  */  {(void*)     aSyShip3DL, 0, (ObjectFunc)          NULL,        aSyShip3Hitbox,  4000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_SY_SHIP_3_DESTROYED  */  {(void*)     aSyShip3DestroyedDL, 0, (ObjectFunc) SectorY_SyShip3Destroyed_Update,        aSyShip3DestroyedHitbox,  4000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_SY_SHIP_4  */  {(void*)     aSyShip4DL, 0, (ObjectFunc)          NULL,        aSyShip4Hitbox,  4000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_SY_SHIP_DEBRIS  */  {(void*) SyShipDebris_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,  2000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_SY_SHIP_2_DESTROYED  */  {(void*)     aSyShip4DestroyedDL, 0, (ObjectFunc) SectorY_SyShip4Destroyed_Update,        aSyShip4DestroyedHitbox,  4000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SPRITE_SY_SHIP_2  */  {(void*)     aSyShip2SpriteDL, 0, (ObjectFunc)          NULL,       gNoHitbox,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SPRITE_SY_SHIP_3  */  {(void*)     aSyShip3SpriteDL, 0, (ObjectFunc)          NULL,       gNoHitbox,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_SY_SHIP_MISSILE  */  {(void*)     aSyShipMissileDL, 0, (ObjectFunc)          NULL,        aSyShipMissileHitbox,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_SY_SHIP_WINDOWS  */  {(void*)     aSyShipWindowsDL, 0, (ObjectFunc)          NULL,        aSyShipWindowsHitbox,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_AQ_CORAL_REEF_1  */  {(void*)     aAqCoralReef1DL, 0, (ObjectFunc)          NULL,        aAqCoralReef1Hitbox,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_AQ_TUNNEL_1  */  {(void*)     aAqTunnel1DL, 0, (ObjectFunc)          NULL,        aAqTunnel1Hitbox,  2000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_AQ_ARCH  */  {(void*)     aAqArchDL, 0, (ObjectFunc)          NULL,        aAqArchHitbox,  2000.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_SCENERY_AQ_CORAL_REEF_2  */  {(void*)     aAqCoralReef2DL, 0, (ObjectFunc)          NULL,        aAqCoralReef2Hitbox,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_AQ_ROCK  */  {(void*)     aAqRockDL, 0, (ObjectFunc)          NULL,        aAqRockHitbox,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_AQ_WALL_1  */  {(void*)     aAqWall1DL, 0, (ObjectFunc)          NULL,        aAqWall1Hitbox,  2000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_AQ_ROOF  */  {(void*)     aAqRoofDL, 0, (ObjectFunc)          NULL,        aAqRoofHitbox,  2000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_AQ_BUMP_1  */  {(void*)     aAqBump2DL, 0, (ObjectFunc)          NULL,       gNoHitbox,  2000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_AQ_TUNNEL_2  */  {(void*)     aAqTunnel2DL, 0, (ObjectFunc)          NULL,        aAqTunnel2Hitbox,  2000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_AQ_BUMP_2  */  {(void*) Aquas_AqBump2_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,  2000.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_VE1_TEMPLE_ENTRANCE  */  {(void*)     aVe1TempleEntranceDL, 0, (ObjectFunc) Venom1_Ve1TempleEntrance_Update,        aVe1TempleEntranceHitbox,  1000.0f,  0, 0, 42, 0,   0.0f,  0 },
  /* OBJ_SCENERY_VE1_TEMPLE_INTERIOR_1  */  {(void*)     aVe1TempleInterior1DL, 0, (ObjectFunc)          NULL,        aVe1TempleInterior1Hitbox,  3200.0f,  0, 0, 42, 0,   0.0f,  0 },
  /* OBJ_SCENERY_VE1_TEMPLE_INTERIOR_2  */  {(void*)     aVe1TempleInterior2DL, 0, (ObjectFunc)          NULL,        aVe1TempleInterior2Hitbox,  3200.0f,  0, 0, 42, 0,   0.0f,  0 },
  /* OBJ_SCENERY_VE1_TEMPLE_INTERIOR_3  */  {(void*)     aVe1TempleInterior3DL, 0, (ObjectFunc)          NULL,        aVe1TempleInterior3Hitbox,  3200.0f,  0, 0, 42, 0,   0.0f,  0 },
  /* OBJ_SCENERY_AND_PASSAGE  */  {(void*) Andross_AndPassage_Draw, 1, (ObjectFunc) Andross_AndPassage_Update,        aAndPassageHitbox,   500.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_AND_DOOR  */  {(void*) Andross_AndDoor_Draw, 1, (ObjectFunc) Andross_AndDoor_Update,        aAndDoorHitbox,   500.0f,  0, 0, 41, 0,   0.0f,  0 },
  /* OBJ_SCENERY_TR_BUILDING  */  {(void*)     aTrBuildingDL, 0, (ObjectFunc)          NULL,        aTrBuildingHitbox,  1000.0f,  0, 0, 20, 0,   0.0f,  0 },
  /* OBJ_SCENERY_AND_PATH_INTERSECTION  */  {(void*)     aAndPathIntersectionDL, 0, (ObjectFunc)          NULL,        aAndPathIntersectionHitbox,     0.0f,  0, 0, 41, 1,   0.0f,  0 },
  /* OBJ_SCENERY_AND_PATH_WALLS  */  {(void*) aAndPathWallsDL, 0, (ObjectFunc)          NULL,        aAndPathHitbox,     0.0f,  0, 0, 41, 1,   0.0f,  0 },
  /* OBJ_SCENERY_AND_PATH_EXIT  */  {(void*)     aAndPathExitDL, 0, (ObjectFunc)          NULL,        aAndPathHitbox,     0.0f,  0, 0, 41, 1,   0.0f,  0 },
  /* OBJ_SCENERY_AND_PATH_ENTRANCE  */  {(void*)     aAndPathEntranceDL, 0, (ObjectFunc)          NULL,       gNoHitbox,     0.0f,  0, 0,  0, 1,   0.0f,  0 },
  /* OBJ_SCENERY_VS_BUILDING_1  */  {(void*)     aVsBuildingDL, 0, (ObjectFunc)          NULL,        aVsBuilding1Hibox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_VS_BUILDING_2  */  {(void*)     aVsBuildingDL, 0, (ObjectFunc)          NULL,        aVsBuilding2Hibox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_VS_PYRAMID_1  */  {(void*)     aVsPyramid1DL, 0, (ObjectFunc)          NULL,       gNoHitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_VS_PYRAMID_2  */  {(void*)     aVsPyramid2DL, 0, (ObjectFunc)          NULL,       gNoHitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_VS_ARCH  */  {(void*)     aVsArchDL, 0, (ObjectFunc)          NULL,        aVsArchHitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_VS_KA_FLBASE  */  {(void*)     aVsKaFlBaseDL, 0, (ObjectFunc)          NULL,        aVsKaFlBaseHitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_VS_SPACE_JUNK_1  */  {(void*)     aVsSpaceJunk1DL, 0, (ObjectFunc)          NULL,        aVsSpaceJunk1Hitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_VS_SPACE_JUNK_2  */  {(void*)     aVsSpaceJunk2DL, 0, (ObjectFunc)          NULL,        aVsSpaceJunk2Hitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_VS_SPACE_JUNK_3  */  {(void*)     aVsSpaceJunk3DL, 0, (ObjectFunc)          NULL,        aVsSpaceJunk3Hitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_LEVEL_OBJECTS  */  {(void*)          NULL, 0, (ObjectFunc)          NULL,       gNoHitbox,     0.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SCENERY_FO_MOUNTAIN_1  */  {(void*)     aFoMountain1DL, 0, (ObjectFunc)          NULL,        aFoMountain1Hitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_FO_MOUNTAIN_2  */  {(void*)     aFoMountain2DL, 0, (ObjectFunc)          NULL,        aFoMountain2Hitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_FO_MOUNTAIN_3  */  {(void*)     aFoMountain3DL, 0, (ObjectFunc)          NULL,        aFoMountain3Hitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_FO_TOWER  */  {(void*)     aFoTowerDL, 0, (ObjectFunc)          NULL,        aFoTowerHitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_BO_POLE  */  {(void*)     aBoPoleDL, 0, (ObjectFunc)          NULL,        aBoPoleHitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_BO_BUILDING  */  {(void*)     aBoBuildingDL, 0, (ObjectFunc)          NULL,        aBoBuildingHitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_KA_FLBASE  */  {(void*)     aKaFLBaseDL, 0, (ObjectFunc)          NULL,        aKaFrontlineBaseHitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_UNK_155  */  {(void*)          NULL, 0, (ObjectFunc)          NULL,       gNoHitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_SY_SHOGUN_SHIP  */  {(void*) SectorY_Scenery156_Draw, 1, (ObjectFunc)          NULL,        aSyScenery156Hitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_SZ_SPACE_JUNK_3  */  {(void*)     aSzSpaceJunk3DL, 0, (ObjectFunc)          NULL,        aSzSpaceJunk3Hitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_SZ_SPACE_JUNK_1  */  {(void*)     aSzSpaceJunk1DL, 0, (ObjectFunc)          NULL,        aSzSpaceJunk1Hitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_VE2_TOWER  */  {(void*)     aVe2TowerDL, 0, (ObjectFunc)          NULL,        aVe2TowerHitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SCENERY_VE2_MOUNTAIN  */  {(void*)     aVe2MountainDL, 0, (ObjectFunc)          NULL,        aVe2MountainHitbox,     0.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SPRITE_CO_POLE  */  {(void*)     aCoPoleDL, 0, (ObjectFunc) Sprite_UpdateDoodad,        aCoPoleHitbox,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SPRITE_CO_TREE  */  {(void*)     aCoTreeDL, 0, (ObjectFunc) Sprite_UpdateDoodad,        aCoTreeHitbox,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SPRITE_FO_POLE  */  {(void*)     aFoPoleDL, 0, (ObjectFunc) Sprite_UpdateDoodad,        aFoPoleHitbox,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SPRITE_FOG_SHADOW  */  {(void*) FogShadow_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,  1800.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SPRITE_CO_RUIN1  */  {(void*)     aCoRuin1DL, 0, (ObjectFunc)          NULL,       gNoHitbox,  -100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SPRITE_CO_RUIN2  */  {(void*)     aCoRuin2DL, 0, (ObjectFunc)          NULL,       gNoHitbox,  -100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SPRITE_167  */  {(void*) Sprite167_Draw, 1, (ObjectFunc) Sprite167_Update,       gNoHitbox,   500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SPRITE_168  */  {(void*) Sprite168_Draw, 1, (ObjectFunc)          NULL,       gNoHitbox,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_SPRITE_TI_CACTUS  */  {(void*)     aTiCactusDL, 0, (ObjectFunc) Titania_Cactus_Update,        aTiCactusHitbox,   100.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SPRITE_CO_SMOKE  */  {(void*)          NULL, 1, (ObjectFunc) Corneria_CoSmoke_Update,       gNoHitbox,     0.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SPRITE_VE1_BOSS_TRIGGER1  */  {(void*)          NULL, 1, (ObjectFunc) Venom1_BossTrigger1_Update,       gNoHitbox,     0.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SPRITE_VE1_BOSS_TRIGGER2  */  {(void*)          NULL, 1, (ObjectFunc) Venom1_BossTrigger2_Update,       gNoHitbox,     0.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SPRITE_VE1_BOSS_TRIGGER3  */  {(void*)          NULL, 1, (ObjectFunc) Venom1_BossTrigger3_Update,       gNoHitbox,     0.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SPRITE_VE1_BOSS_TRIGGER4  */  {(void*)          NULL, 1, (ObjectFunc) Venom1_BossTrigger4_Update,       gNoHitbox,     0.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_SPRITE_GFOX_TARGET  */  {(void*)          NULL, 1, (ObjectFunc)          NULL,       gNoHitbox,  1000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ACTOR_CO_GARUDA_1 */  {(void*) Corneria_CoGaruda1_Draw, 2, (ObjectFunc) Corneria_CoGaruda1_Update,        CoGarudaHitbox,   500.0f,  0, 0, 39, 1, 200.0f,  1 },
  /* OBJ_ACTOR_CO_GARUDA_2 */  {(void*) Corneria_CoGaruda2_Draw, 2, (ObjectFunc) Corneria_CoGaruda2_Update,        CoGarudaHitbox,   500.0f,  0, 0, 39, 1, 200.0f,  1 },
  /* OBJ_ACTOR_CO_GARUDA_3 */  {(void*) Corneria_CoGaruda3_Draw, 2, (ObjectFunc) Corneria_CoGaruda3_Update,        CoGarudaHitbox,   500.0f,  0, 0, 39, 1, 200.0f,  1 },
  /* OBJ_ACTOR_CO_GARUDA_DESTROY */  {(void*) Corneria_CoGarudaDestroy_Draw, 2, (ObjectFunc) Corneria_CoGarudaDestroy_Update,        aCoGarudaDestroyHitbox,   500.0f,  0, 0, 39, 1,   0.0f,  1 },
  /* OBJ_ACTOR_ME_MOLAR_ROCK */  {(void*) MeMolarRock_Draw, 1, (ObjectFunc) MeMolarRock_Update,       gNoHitbox,  1000.0f,  0, 0, 39, 0,   0.0f,  1 },
  /* OBJ_ACTOR_ME_METEOR_1 */  {(void*)     aMeMeteor1DL, 0, (ObjectFunc) Meteo_MeMeteor1_Update,        aMeMeteor1Hitbox,   200.0f,  0, 0, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_ME_METEOR_2 */  {(void*) MeMeteor2_Draw, 1, (ObjectFunc) Meteo_MeMeteor2_Update,        aMeMeteor2Hitbox,   100.0f,  0, 1, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_ME_METEOR_SHOWER_1 */  {(void*) Meteo_MeMeteorShower1_Draw, 1, (ObjectFunc) Meteo_MeteorShower_Update,       gNoHitbox,   100.0f,  0, 1, 39, 0,   0.0f,  1 },
  /* OBJ_ACTOR_ME_METEOR_SHOWER_2 */  {(void*) Meteo_MeMeteorShower2_Draw, 1, (ObjectFunc) Meteo_MeteorShower_Update,       gNoHitbox,   100.0f,  0, 1, 39, 0,   0.0f,  1 },
  /* OBJ_ACTOR_ME_METEOR_SHOWER_3 */  {(void*) Meteo_MeMeteorShower3_Draw, 1, (ObjectFunc) Meteo_MeteorShower_Update,       gNoHitbox,   100.0f,  0, 1, 39, 0,   0.0f,  1 },
  /* OBJ_ACTOR_ME_LASER_CANNON_1 */  {(void*) MeLaserCannon1_Draw, 1, (ObjectFunc) Meteo_MeLaserCannon1_Update,        aMeLaserCannon1Hitbox,   200.0f,  0, 1, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_ME_LASER_CANNON_2 */  {(void*)     aMeLaserCannon2DL, 0, (ObjectFunc) Meteo_MeLaserCannon2_Update,        aMeLaserCannon2Hitbox,   200.0f,  0, 1, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_AQ_UNK_188 */  {(void*) Aquas_Actor188_Draw, 1, (ObjectFunc) Aquas_Actor188_Update,        aAqActor188Hitbox,   200.0f,  0, 1, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_DEBRIS */  {(void*) ActorDebris_Draw, 1, (ObjectFunc) ActorDebris_Update,       gNoHitbox,     0.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_MISSILE_SEEK_TEAM */  {(void*) ActorMissileSeek_Draw, 1, (ObjectFunc) ActorMissileSeek_Update,       gActorMissileSeekHitbox,   100.0f,  0, 1, 39, 0,   1.0f,  0 },
  /* OBJ_MISSILE_SEEK_PLAYER */  {(void*) ActorMissileSeek_Draw, 1, (ObjectFunc) ActorMissileSeek_Update,       gActorMissileSeekHitbox,   100.0f,  0, 1, 39, 0,   1.0f,  0 },
  /* OBJ_ACTOR_CO_SKIBOT */  {(void*) CoSkibot_Draw, 1, (ObjectFunc) CoSkibot_Update,        aCoActorSkibotHitbox,   200.0f,  0, 1, 39, 0,  50.0f,  1 },
  /* OBJ_ACTOR_CO_RADAR */  {(void*) CoRadar_Draw, 1, (ObjectFunc) CoRadar_Update,        aCoActorRadarHitbox,   100.0f,  0, 1, 39, 0,   0.0f,  0 },
  /* OBJ_ACTOR_ME_MORA */  {(void*) MeMora_Draw, 1, (ObjectFunc) MeMora_Update,       gMeMoraHitbox,   200.0f,  0, 1, 39, 0,   0.0f,  1 },
  /* OBJ_ACTOR_CUTSCENE */  {(void*) ActorCutscene_Draw, 1, (ObjectFunc) ActorCutscene_Update,       gNoHitbox, 20000.0f,  0, 1, 39, 0,   0.0f,  0 },
  /* OBJ_ACTOR_CO_MOLE_MISSILE */  {(void*) CoMoleMissile_Draw, 1, (ObjectFunc) CoMoleMissile_Update,        aCoMoleMissileHitbox,   200.0f,  0, 1, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_ALLRANGE */  {(void*) ActorAllRange_Draw, 1, (ObjectFunc) ActorAllRange_Update,       gActorAllRangeHItbox, 20000.0f,  0, 1, 39, 1,   1.0f,  1 },
  /* OBJ_ACTOR_TEAM_BOSS */  {(void*) ActorAllRange_Draw, 1, (ObjectFunc) ActorTeamBoss_Update,       gTeamHitbox, 20000.0f,  0, 0, 39, 1,   0.0f,  0 },
  /* OBJ_ACTOR_TEAM_ARWING */  {(void*) Andross_ActorTeamArwing_Draw, 1, (ObjectFunc) Andross_ActorTeamArwing_Update,       gNoHitbox, 20000.0f,  0, 0, 39, 1,   0.0f,  0 },
  /* OBJ_ACTOR_EVENT */  {(void*) ActorEvent_Draw, 1, (ObjectFunc) ActorEvent_Update,       gNoHitbox,  2000.0f,  0, 1, 39, 0,   0.0f,  1 },
  /* OBJ_ACTOR_ME_METEO_BALL */  {(void*) MeteoBall_Draw, 1, (ObjectFunc) MeteoBall_Update,        aMeMeteoBallHitbox,   100.0f,  0, 1, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_ME_HOPBOT */  {(void*) MeHopBot_Draw, 1, (ObjectFunc) MeHopBot_Update,        aMeHopBotHitbox,   100.0f,  0, 1, 39, 0, 180.0f,  1 },
  /* OBJ_ACTOR_SX_SLIPPY */  {(void*) SectorX_SxSlippy_Draw, 1, (ObjectFunc) SectorX_SxSlippy_Update,       gNoHitbox,  1000.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_ACTOR_SY_ROBOT */  {(void*) SectorY_SyRobot_Draw, 1, (ObjectFunc) SectorY_SyRobot_Update,        aSyRobotHitbox,  1000.0f,  0, 0, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_MA_LOCOMOTIVE */  {(void*) Macbeth_Train_Draw, 1, (ObjectFunc) Macbeth_MaLocomotive_Update,        aMaLocomotiveHitbox, 20000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_MA_TRAIN_CAR_1 */  {(void*) Macbeth_Train_Draw, 1, (ObjectFunc) Macbeth_MaTrainCar1_Update,        aMaTrainCar1Hitbox, 20000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_207 */  {(void*) Macbeth_Actor207_Draw, 2, (ObjectFunc) Macbeth_Actor207_Update,        aMaActor207Hitbox, 20000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_MA_TRAIN_CAR_2 */  {(void*) Macbeth_Train_Draw, 1, (ObjectFunc) Macbeth_MaTrainCar2_Update,        aMaTrainCar2Hitbox, 20000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_MA_TRAIN_CAR_3 */  {(void*) Macbeth_Train_Draw, 1, (ObjectFunc) Macbeth_MaTrainCar3_Update,        aMaTrainCar3Hitbox, 20000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_MA_TRAIN_CAR_4 */  {(void*) Macbeth_Train_Draw, 1, (ObjectFunc) Macbeth_MaTrainCar4_Update,        aMaTrainCar4Hitbox, 20000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_MA_TRAIN_CAR_5 */  {(void*) Macbeth_Train_Draw, 1, (ObjectFunc) Macbeth_MaTrainCar5_Update,        aMaTrainCar5Hitbox, 20000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_MA_TRAIN_CAR_6 */  {(void*) Macbeth_Train_Draw, 1, (ObjectFunc) Macbeth_MaTrainCar6_Update,        aMaTrainCar6Hitbox, 20000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_MA_TRAIN_CAR_7 */  {(void*) Macbeth_Train_Draw, 1, (ObjectFunc) Macbeth_MaTrainCar7_Update,        aMaTrainCar7Hitbox, 20000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_MA_RAILROAD_SWITCH */  {(void*) Macbeth_MaRailroadSwitch_Draw, 1, (ObjectFunc) Macbeth_MaRailroadSwitch_Update,        aMaMaRailroadSwitchHitbox,   300.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_MA_BOULDER */  {(void*) Macbeth_MaBoulder_Draw, 1, (ObjectFunc) Macbeth_MaBoulder_Update,        aMaBoulderHitbox,   300.0f,  0, 1, 40, 1,   0.0f,  1 },
  /* OBJ_ACTOR_MA_HORIZONTAL_LOCK_BAR */  {(void*) Macbeth_MaHorizontalLockBar_Draw, 1, (ObjectFunc) Macbeth_MaHorizontalLockBar_Update,        aMaHorizontalLockBarHitbox,   200.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_MA_VERTICAL_LOCK_BAR */  {(void*) Macbeth_MaVerticalLockBar_Draw, 1, (ObjectFunc) Macbeth_MaVerticalLockBar_Update,        aMaVerticalLockBarHitbox,   200.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_MA_BARRIER */  {(void*) Macbeth_MaBarrier_Draw, 1, (ObjectFunc) Macbeth_MaBarrier_Update,        aMaBarrierHitbox,   200.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_MA_FALLING_BOULDER */  {(void*) Macbeth_MaFallingBoulder_Draw, 1, (ObjectFunc) Macbeth_MaFallingBoulder_Update,        aMaFallingBoulderHitbox,   300.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_MA_BOMBDROP */  {(void*) Macbeth_MaBombDrop_Draw, 1, (ObjectFunc) Macbeth_MaBombDrop_Update,        aMaBombDropHitbox,   200.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_MA_SPEAR */  {(void*) Macbeth_MaSpear_Draw, 1, (ObjectFunc) Macbeth_MaSpear_Update,        aMaSpearHitbox,   300.0f,  0, 0, 40, 1,   1.0f,  0 },
  /* OBJ_ACTOR_MA_SHOCK_BOX */  {(void*) Macbeth_MaShockBox_Draw, 1, (ObjectFunc) Macbeth_MaShockBox_Update,        aMaShockBoxHitbox,   300.0f,  0, 0, 40, 1,   1.0f,  0 },
  /* OBJ_ACTOR_MA_RAILWAY_SIGNAL */  {(void*) Macbeth_MaRailwaySignal_Draw, 1, (ObjectFunc) Macbeth_MaRailwaySignal_Update,        aMaRailwaySignalHitbox,   300.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_TI_TERRAIN */  {(void*)          NULL, 1, (ObjectFunc) Titania_TiTerrain_Update,       gNoHitbox,   200.0f,  0, 0, 39, 0,   0.0f,  0 },
  /* OBJ_ACTOR_TI_LANDMINE */  {(void*)     aTi1LandmineDL, 0, (ObjectFunc) Titania_TiLandmine_Update,        aTi1LandmineHitbox,    50.0f,  0, 0, 39, 1,   1.0f,  0 },
  /* OBJ_ACTOR_TI_DESERT_ROVER */  {(void*) Titania_TiDesertRover_Draw, 1, (ObjectFunc) Titania_TiDesertRover_Update,        aTiDesertRoverHitbox,   300.0f,  0, 0, 39, 1,  70.0f,  1 },
  /* OBJ_ACTOR_TI_DELPHOR */  {(void*) Titania_TiDelphor_Draw, 1, (ObjectFunc) Titania_TiDelphor_Update,        aTiDelphorHitbox,     0.0f,  0, 0, 39, 1,   0.0f,  0 },
  /* OBJ_ACTOR_TI_DELPHOR_HEAD */  {(void*) Titania_TiDelphorHead_Draw, 1, (ObjectFunc) Titania_TiDelphorHead_Update,        aTiDelphorHeadHitbox,     0.0f,  0, 0, 39, 1,   1.0f,  1 },
  /* OBJ_ACTOR_TI_DESERT_CRAWLER */  {(void*) Titania_TiDesertCrawler_Draw, 1, (ObjectFunc) Titania_TiDesertCrawler_Update,        aTiDesertCrawlerHitbox,  1000.0f,  0, 0, 20, 1,   0.0f,  1 },
  /* OBJ_ACTOR_TI_BOULDER */  {(void*) Titania_TiBoulder_Draw, 1, (ObjectFunc) Titania_TiBoulder_Update,        aTiBoulderHitbox,     0.0f,  0, 1, 39, 1,   0.0f,  1 },
  /* OBJ_ACTOR_TI_BOMB */  {(void*) Titania_TiBomb_Draw, 1, (ObjectFunc) Titania_TiBomb_Update,        aTiBombHitbox,     0.0f,  0, 0, 39, 1,   0.0f,  1 },
  /* OBJ_ACTOR_TI_RASCO */  {(void*) Titania_TiRasco_Draw, 1, (ObjectFunc) Titania_TiRasco_Update,    aTiRascoHitbox,     0.0f,  0, 0, 39, 1,  20.0f,  1 },
  /* OBJ_ACTOR_TI_FEKUDA */  {(void*) Titania_TiFekuda_Draw, 1, (ObjectFunc) Titania_TiFekuda_Update,        aTiFekudaHitbox,   200.0f,  0, 0, 39, 1,   1.0f,  1 },
  /* OBJ_ACTOR_TI_GREAT_FOX */  {(void*) TiGreatFox_Draw, 1, (ObjectFunc) TiGreatFox_Update,       gNoHitbox,  2000.0f,  0, 0, 39, 0,   0.0f,  5 },
  /* OBJ_ACTOR_ZO_BIRD */  {(void*) Zoness_ZoBird_Draw, 2, (ObjectFunc) Zoness_ZoBird_Update,        aZoBirdHitbox,  1000.0f,  0, 1, 40, 0,   1.0f,  1 },
  /* OBJ_ACTOR_ZO_DODORA */  {(void*) Zoness_ZoDodora_Draw, 1, (ObjectFunc) Zoness_ZoDodora_Update,        aZoDodoraHitbox,  5000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_UNK_237 */  {(void*) Actor237_Draw, 1, (ObjectFunc) Actor237_Update,       gNoHitbox,   200.0f,  0, 0, 40, 0,   0.0f,  2 },
  /* OBJ_ACTOR_ZO_FISH */  {(void*) Zoness_ZoFish_Draw, 2, (ObjectFunc) Zoness_ZoFish_Update,       gCubeHitbox100,   200.0f,  0, 1, 40, 0,   1.0f,  1 },
  /* OBJ_ACTOR_ZO_DODORA_WP_COUNT */  {(void*)          NULL, 1, (ObjectFunc)          NULL,       gNoHitbox,  1000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ACTOR_ZO_Z_GULL */  {(void*) Zoness_ZGull_Draw, 1, (ObjectFunc) Zoness_ZGull_Update,       gCubeHitbox100,  1500.0f,  0, 1, 40, 0,  20.0f,  0 },
  /* OBJ_ACTOR_ZO_ENERGY_BALL */  {(void*) Zoness_ZoEnergyBall_Draw, 1, (ObjectFunc) Zoness_ZoEnergyBall_Update,       gZoEnergyBallHitbox,  1500.0f,  0, 1, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_ZO_TROIKA */  {(void*) Zoness_ZoTroika_Draw, 2, (ObjectFunc) Zoness_ZoTroika_Update,        aZoTroikaHitbox,   500.0f,  0, 0, 40, 0,   1.0f,  0 },
  /* OBJ_ACTOR_ZO_SHRIMP */  {(void*) Zoness_ZoShrimp_Draw, 2, (ObjectFunc) Zoness_ZoShrimp_Update,       gCubeHitbox100,     0.0f,  0, 1, 40, 0,   1.0f,  1 },
  /* OBJ_ACTOR_ZO_OBNEMA */  {(void*) Zoness_ZoObnema_Draw, 2, (ObjectFunc) Zoness_ZoObnema_Update,        aZoObnemaHitbox,  2000.0f,  0, 0, 40, 0,  50.0f,  0 },
  /* OBJ_ACTOR_ZO_BALL */  {(void*) Zoness_ZoBall_Draw, 1, (ObjectFunc) Zoness_ZoBall_Update,       gCubeHitbox100,   200.0f,  0, 0, 40, 0,   1.0f,  0 },
  /* OBJ_ACTOR_ZO_MINE */  {(void*) Zoness_ZoMine_Draw, 1, (ObjectFunc) Zoness_ZoMine_Update,       gCubeHitbox100,  2000.0f,  0, 0, 40, 0,   1.0f,  0 },
  /* OBJ_ACTOR_ZO_BARRIER */  {(void*) Zoness_ZoBarrier_Draw, 1, (ObjectFunc) Zoness_ZoBarrier_Update,        aZoBarrierHitbox,   500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_ZO_CRANE_MAGNET */  {(void*) Zoness_ZoCraneMagnet_Draw, 1, (ObjectFunc) Zoness_ZoCraneMagnet_Update,       gCubeHitbox150,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_SPIKEBALL */  {(void*) Zoness_ZoSpikeBall_Draw, 1, (ObjectFunc) Zoness_ZoSpikeBall_Update,       gCubeHitbox200,  5000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_ZO_TANKER */  {(void*) Zoness_ZoTanker_Draw, 1, (ObjectFunc) Zoness_ZoTanker_Update,        aZoTankerHitbox, 10000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_ZO_CONTAINER */  {(void*) Zoness_ZoContainer_Draw, 2, (ObjectFunc) Zoness_ZoContainer_Update,        aZoContainerHitbox,  1000.0f,  0, 0, 40, 0,   1.0f,  1 },
  /* OBJ_ACTOR_ZO_RADARBUOY */  {(void*) Zoness_ZoRadarBuoy_Draw, 1, (ObjectFunc) Zoness_ZoRadarBuoy_Update,        aZoRadarBuoyHitbox,   200.0f,  0, 0, 40, 0,  80.0f,  1 },
  /* OBJ_ACTOR_ZO_SUPPLYCRANE */  {(void*) Zoness_ZoSupplyCrane_Draw, 1, (ObjectFunc) Zoness_ZoSupplyCrane_Update,        aZoSupplyCraneHitbox,   300.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_ZO_SEARCHLIGHT */  {(void*) Zoness_ZoSearchLight_Draw, 1, (ObjectFunc) Zoness_ZoSearchLight_Update,        aZoSearchLightHitbox,   300.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ACTOR_255 */  {(void*) Aquas_Actor255_Draw, 1, (ObjectFunc) Aquas_Actor255_Update,        aAqActor255Hitbox,   500.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_256 */  {(void*) Aquas_Actor256_Draw, 1, (ObjectFunc) Aquas_Actor256_Update,        aAqActor256Hitbox, 10000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_257 */  {(void*) Aquas_Actor257_Draw, 1, (ObjectFunc) Aquas_Actor257_Update,        aAqActor257Hitbox, 10000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_AQ_PEARL */  {(void*) Aquas_AqPearl_Draw, 1, (ObjectFunc) Aquas_AqPearl_Update,       gCubeHitbox100,   200.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_AQ_ANGLERFISH */  {(void*) Aquas_AqAnglerFish_Draw, 2, (ObjectFunc) Aquas_AqAnglerFish_Update,        aAqAnglerFishHitbox, 10000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_AQ_GAROA */  {(void*) Aquas_AqGaroa_Draw, 2, (ObjectFunc) Aquas_AqGaroa_Update,        aAqGaroaHitbox,   300.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_AQ_SCULPIN */  {(void*) Aquas_AqSculpin_Draw, 2, (ObjectFunc) Aquas_AqSculpin_Update,        aAqSculpinHitbox,   300.0f,  0, 0, 40, 0,   0.0f,  1 },
  /* OBJ_ACTOR_AQ_SPINDLYFISH */  {(void*) Aquas_AqSpindlyFish_Draw, 2, (ObjectFunc) Aquas_AqSpindlyFish_Update,        aAqSpindlyFishHitbox,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_AQ_SQUID */  {(void*) Aquas_AqSquid_Draw, 2, (ObjectFunc) Aquas_AqSquid_Update,        aAqSquidHitbox,   200.0f,  0, 0, 40, 0,   0.0f,  1 },
  /* OBJ_ACTOR_AQ_SEAWEED */  {(void*) Aquas_AqSeaweed_Draw, 1, (ObjectFunc) Aquas_AqSeaweed_Update,       gCubeHitbox100,   200.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ACTOR_AQ_BOULDER */  {(void*) Aquas_AqBoulder_Draw, 1, (ObjectFunc) Aquas_AqBoulder_Update,        aAqBoulderHitbox,   200.0f,  0, 0, 40, 0,   0.0f,  1 },
  /* OBJ_ACTOR_AQ_CORAL */  {(void*) Aquas_AqCoral_Draw, 2, (ObjectFunc) Aquas_AqCoral_Update,        aAqCoralHitbox,   200.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ACTOR_AQ_JELLYFISH */  {(void*) Aquas_AqJellyfish_Draw, 2, (ObjectFunc) Aquas_AqJellyfish_Update,        aAqJellyfishHitbox,   800.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_AQ_FISHGROUP */  {(void*) Aquas_AqFishGroup_Draw, 1, (ObjectFunc) Aquas_AqFishGroup_Update,        aAqFishGroupHitbox, 10000.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ACTOR_AQ_STONE_COLUMN */  {(void*) Aquas_AqStoneColumn_Draw, 1, (ObjectFunc) Aquas_AqStoneColumn_Update,        aAqStoneColumnHitbox,  2000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_AQ_OYSTER */  {(void*) Aquas_AqOyster_Draw, 1, (ObjectFunc) Aquas_AqOyster_Update,        aAqOysterHitbox,  1000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_BO_SHIELD_REACTOR */  {(void*) BoShieldReactor_Draw, 2, (ObjectFunc) BoShieldReactor_Update,        aBoShieldReactorHitbox,     0.0f,  0, 0, 39, 0, 730.0f,  1 },
  /* OBJ_ACTOR_BO_LASER_CANNON */  {(void*) BoLaserCannon_Draw, 1, (ObjectFunc) BoLaserCannon_Update,        aBoLaserCannonHitbox,     0.0f,  0, 0, 39, 0, 150.0f,  1 },
  /* OBJ_ACTOR_FO_RADAR */  {(void*) Fortuna_FoRadar_Draw, 2, (ObjectFunc) Fortuna_FoRadar_Update,        aFoRadarHitbox,     0.0f,  0, 0, 39, 0, 220.0f,  1 },
  /* OBJ_ACTOR_SZ_SPACE_JUNK */  {(void*) SectorZ_SpaceJunkDraw, 1, (ObjectFunc) SectorZ_SpaceJunkUpdate,       gCubeHitbox200,     0.0f,  0, 0, 39, 0,   1.0f,  0 },
  /* OBJ_ACTOR_SO_ROCK_1 */  {(void*) Solar_SoRock_Draw, 1, (ObjectFunc) Solar_SoRock_Update,       gCubeHitbox100,   200.0f,  0, 0, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_SO_ROCK_2 */  {(void*) Solar_SoRock_Draw, 1, (ObjectFunc) Solar_SoRock_Update,       gCubeHitbox100,   200.0f,  0, 0, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_SO_ROCK_3 */  {(void*) Solar_SoRock_Draw, 1, (ObjectFunc) Solar_SoRock_Update,       gCubeHitbox200,   200.0f,  0, 0, 39, 0,   1.0f,  1 },
  /* OBJ_ACTOR_SO_WAVE */  {(void*) NULL, 1, (ObjectFunc) Solar_SoWave_Update,       gNoHitbox,   200.0f,  0, 0,  0, 0,   0.0f,  1 },
  /* OBJ_ACTOR_SO_PROMINENCE */  {(void*) NULL, 1, (ObjectFunc) Solar_SoProminence_Update,       gNoHitbox,  1000.0f,  0, 0,  0, 0,   0.0f,  1 },
  /* OBJ_ACTOR_VE1_PILLAR_1 */  {(void*) aVe1Pillar1DL, 0, (ObjectFunc) Venom1_Ve1Pillar1_Update,        aVe1Pillar1Hitbox,  1000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_VE1_PILLAR_2 */  {(void*) Venom1_Ve1Pillar2_Draw, 1, (ObjectFunc) Venom1_Pillar2_3_Update,        aVe1Pillar2Hitbox,  1000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_VE1_PILLAR_3 */  {(void*)     aVe1Pillar3DL, 0, (ObjectFunc) Venom1_Pillar2_3_Update,        aVe1Pillar3Hitbox,  1000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_VE1_PILLAR_4 */  {(void*)     aVe1Pillar4DL, 0, (ObjectFunc) Venom1_Ve1Pillar4_Update,        aVe1Pillar4Hitbox,  1000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_VE1_MONKEY_STATUE */  {(void*) Venom1_Ve1MonkeyStatue_Draw, 1, (ObjectFunc) Venom1_Ve1MonkeyStatue_Update,        aVe1MonkeyStatueHitbox,  1000.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_ACTOR_AND_LASER_EMITTER */  {(void*) Andross_AndLaserEmitter_Draw, 1, (ObjectFunc) Andross_AndLaserEmitter_Update,       gCubeHitbox100,  1000.0f,  0, 0, 20, 0,   1.0f,  1 },
  /* OBJ_ACTOR_AND_BRAIN_WASTE */  {(void*) Andross_AndBrainWaste_Draw, 1, (ObjectFunc) Andross_AndBrainWaste_Update,       gCubeHitbox100,  1000.0f,  0, 0, 20, 0,   0.0f,  0 },
  /* OBJ_ACTOR_AND_EXPLOSION */  {(void*)          NULL, 1, (ObjectFunc) Andross_AndExplosion_Update,       gNoHitbox,  1000.0f,  0, 0, 40, 1,   0.0f,  0 },
  /* OBJ_ACTOR_AND_RADIO */  {(void*)          NULL, 1, (ObjectFunc) Andross_AndRadio_Update,       gNoHitbox,  1000.0f,  0, 0, 20, 1,   0.0f,  0 },
  /* OBJ_ACTOR_AND_JAMES_TRIGGER */  {(void*) AndJamesTrigger_Draw, 1, (ObjectFunc) Andross_AndJamesTrigger_Update,       gNoHitbox,  1000.0f,  0, 0, 20, 1,   0.0f,  0 },
  /* OBJ_ACTOR_AND_BOSS_TIMER_SET */  {(void*)          NULL, 1, (ObjectFunc) Andross_AndBossTimer_Update,       gNoHitbox,  1000.0f,  0, 0, 20, 0,   0.0f,  0 },
  /* OBJ_ACTOR_SUPPLIES */  {(void*) ActorSupplies_Draw, 1, (ObjectFunc) ActorSupplies_Update,       gCubeHitbox150,  1000.0f,  0, 0,  0, 0,   1.0f,  0 },
  /* OBJ_BOSS_CO_GRANGA */  {(void*) Corneria_CoGranga_Draw, 2, (ObjectFunc) Corneria_CoGranga_Update,        aCoGrangaHitbox, 20000.0f,  0, 0, 40, 1,   0.0f, 10 },
  /* OBJ_BOSS_CO_CARRIER */  {(void*) Corneria_CoCarrier_Draw, 1, (ObjectFunc) Corneria_CoCarrier_Update,        aCoCarrierHitbox, 20000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_CO_CARRIER_LEFT */  {(void*) Corneria_CoCarrierLeft_Draw, 1, (ObjectFunc) Corneria_CarrierLeft_Update,        aCoCarrierLeftHitbox, 20000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_CO_CARRIER_UPPER */  {(void*) Corneria_CoCarrierUpper_Draw, 1, (ObjectFunc) Corneria_CarrierUpper_Update,        aCoCarrierUpperHitbox, 20000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_CO_CARRIER_BOTTOM */  {(void*) Corneria_CoCarrierBottom_Draw, 1, (ObjectFunc) Corneria_CarrierBottom_Update,        aCoCarrierBottomHitbox, 20000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_ME_CRUSHER */  {(void*) Meteo_MeCrusher_Draw, 1, (ObjectFunc) Meteo_MeCrusher_Update,        aMeCrusherHitbox, 20000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_ME_CRUSHER_SHIELD */  {(void*) Meteo_MeCrusherShield_Draw, 1, (ObjectFunc) Meteo_MeCrusherShield_Update,        aMeCrusherShieldHitbox, 20000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_UNK_299 */  {(void*) Boss299_Draw, 2, (ObjectFunc) Boss299_Update,       gNoHitbox, 20000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_UNK_300 */  {(void*) Boss300_Draw, 1, (ObjectFunc) Boss300_Update,       gNoHitbox, 20000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_AQ_UNK_301 */  {(void*) Aquas_Boss301_Draw, 1, (ObjectFunc) Aquas_Boss301_Update,        aBoss301Hitbox,     0.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_A6_GORGON */  {(void*) Area6_A6Gorgon_Draw, 1, (ObjectFunc) Area6_A6Gorgon_Update,        aA6GorgonHitbox,  2000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_SX_SPYBORG */  {(void*) SectorX_SxSpyborg_Draw, 2, (ObjectFunc) SectorX_SxSpyborg_Update,        aSxSpyborgHitbox, 20000.0f,  0, 0, 20, 0,   0.0f, 10 },
  /* OBJ_BOSS_SX_SPYBORG_LEFT_ARM */  {(void*) SectorX_SxSpyborgLeftArm_Draw, 2, (ObjectFunc) SectorX_SxSpyborgLeftArm_Update,        aSxSpyborgLeftArmHitbox,  1000.0f,  0, 0, 20, 0,   0.0f, 10 },
  /* OBJ_BOSS_SX_SPYBORG_RIGHT_ARM */  {(void*) SectorX_SxSpyborgRightArm_Draw, 2, (ObjectFunc) SectorX_SxSpyborgRightArm_Update,        aSxSpyborgRightArmHitbox,  1000.0f,  0, 0, 20, 0,   0.0f, 10 },
  /* OBJ_BOSS_TI_GORAS */  {(void*) Titania_TiGoras_Draw, 1, (ObjectFunc) Titania_TiGoras_Update, aTiGorasHitbox,  1000.0f,  0, 0, 40, 1,   0.0f, 10 },
  /* OBJ_BOSS_ZO_SARUMARINE */  {(void*) Zoness_ZoSarumarine_Draw, 2, (ObjectFunc) Zoness_ZoSarumarine_Update,        aZoSarumarineHitbox,  1000.0f,  0, 0, 40, 0,   1.0f, 10 },
  /* OBJ_BOSS_FO_BASE */  {(void*) FoBase_Draw, 1, (ObjectFunc) FoBase_Update,        aFoBaseHitbox,     0.0f,  0, 0, 40, 1,   0.0f, 10 },
  /* OBJ_BOSS_BO_BASE */  {(void*) BoBase_Draw, 1, (ObjectFunc) BoBase_Update,       gNoHitbox,     0.0f,  0, 0, 40, 1,   0.0f, 10 },
  /* OBJ_BOSS_BO_BASE_SHIELD */  {(void*) BoBaseShield_Draw, 1, (ObjectFunc) BoBaseShield_Update,       gNoHitbox,     0.0f,  0, 0, 40, 1,   0.0f, 10 },
  /* OBJ_BOSS_BO_BASE_CORE */  {(void*) Bolse_BoBaseCore_Draw, 2, (ObjectFunc) Bolse_BoBaseCore_Update,        aBoBaseCoreHitbox,     0.0f,  0, 0, 40, 1,   0.0f, 10 },
  /* OBJ_BOSS_VE2_BASE */  {(void*) Venom2_Ve2Base_Draw, 2, (ObjectFunc) Venom2_Ve2Base_Update,        aVe2BaseHitbox,     0.0f,  0, 0, 40, 1,   0.0f, 10 },
  /* OBJ_BOSS_SZ_GREAT_FOX */  {(void*) SectorZ_SzGreatFox_Draw, 1, (ObjectFunc) SectorZ_SzGreatFox_Update,        aSzGreatFoxHitbox,     0.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_SY_SHOGUN */  {(void*) SectorY_SyShogun_Draw, 2, (ObjectFunc) SectorY_SyShogun_Update,       gNoHitbox,     0.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_SO_VULKAIN */  {(void*) Solar_SoVulkain_Draw, 2, (ObjectFunc) Solar_SoVulkain_Update,       gNoHitbox,     0.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_KA_SAUCERER */  {(void*) Katina_KaSaucerer_Draw, 1, (ObjectFunc) Katina_KaSaucerer_Update,        aKaSaucererHitbox,     0.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_KA_FLBASE */  {(void*) Katina_KaFrontlineBase_Draw, 1, (ObjectFunc) Katina_KaFrontlineBase_Update,        aKaFrontlineBaseHitbox,     0.0f,  0, 0, 40, 1,   0.0f, 10 },
  /* OBJ_BOSS_AQ_BACOON */  {(void*) Aquas_AqBacoon_Draw, 2, (ObjectFunc) Aquas_AqBacoon_Update,        aAqBacoonHitbox, 10000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_VE1_GOLEMECH */  {(void*) Venom1_Ve1Golemech_Draw, 1, (ObjectFunc) Venom1_Ve1Golemech_Update, aVe1GolemechHitbox,  3000.0f,  0, 0, 40, 1,   0.0f, 10 },
  /* OBJ_BOSS_AND_ANDROSS */  {(void*) Andross_AndAndross_Draw, 2, (ObjectFunc) Andross_AndAndross_Update,        aAndAndrossHitbox, 10000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_BOSS_AND_BRAIN */  {(void*) Andross_AndBrain_Draw, 1, (ObjectFunc) Andross_AndBrain_Update,        aAndBrainHitbox, 10000.0f,  0, 0, 40, 0,   0.0f, 10 },
  /* OBJ_ITEM_LASERS  */  {(void*) ItemLasers_Draw, 1, (ObjectFunc) ItemLasers_Update,       gItemLasersHitbox,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_CHECKPOINT  */  {(void*) ItemCheckpoint_Draw, 1, (ObjectFunc) ItemCheckpoint_Update,       gItemCheckpointHitbox,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_SILVER_RING  */  {(void*) ItemSilverRing_Draw, 1, (ObjectFunc) ItemSupplyRing_Update,       gItemSupplyRingHitbox,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_SILVER_STAR  */  {(void*) ItemSilverStar_Draw, 1, (ObjectFunc) ItemSilverStar_Update,       gItemSupplyRingHitbox,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_METEO_WARP  */  {(void*) ItemMeteoWarp_Draw, 1, (ObjectFunc) ItemMeteoWarp_Update,       gMeteoWarpHitbox,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_BOMB  */  {(void*) ItemBomb_Draw, 1, (ObjectFunc) ItemPickup_Update,       gItemBombHitbox,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_PATH_SPLIT_X  */  {(void*)          NULL, 1, (ObjectFunc) ItemPathChange_Update,       gItemPathChangeHitbox,  1500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_PATH_TURN_LEFT  */  {(void*)          NULL, 1, (ObjectFunc) ItemPathChange_Update,       gItemPathChangeHitbox,  1500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_PATH_TURN_RIGHT  */  {(void*)          NULL, 1, (ObjectFunc) ItemPathChange_Update,       gItemPathChangeHitbox,  1500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_PATH_SPLIT_Y  */  {(void*)          NULL, 1, (ObjectFunc) ItemPathChange_Update,       gItemPathChangeHitbox,  1500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_PATH_TURN_UP  */  {(void*)          NULL, 1, (ObjectFunc) ItemPathChange_Update,       gItemPathChangeHitbox,  1500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_PATH_TURN_DOWN  */  {(void*)          NULL, 1, (ObjectFunc) ItemPathChange_Update,       gItemPathChangeHitbox,  1500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_RING_CHECK  */  {(void*)          NULL, 1, (ObjectFunc) ItemRingCheck_Update,       gItemRingCheckHitbox,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_1UP  */  {(void*)     D_1022120, 0, (ObjectFunc) Item1up_Update,       gCubeHitbox100,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_GOLD_RING  */  {(void*) ItemGoldRing_Draw, 1, (ObjectFunc) ItemGoldRing_Update,       gItemSupplyRingHitbox,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_WING_REPAIR  */  {(void*)     aArwingItemLasersDL, 0, (ObjectFunc) ItemWingRepair_Update,       gItemLasersHitbox,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_ITEM_TRAINING_RING  */  {(void*)     aItemTrainingRingDL, 0, (ObjectFunc) Training_ItemRing_Update,        aItemTrainingRingHitbox,   700.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_FIRE_SMOKE_1  */  {(void*) Effect_FireSmoke_Draw, 1, (ObjectFunc) Effect_Effect339_Update,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_FIRE_SMOKE_2  */  {(void*) Effect_FireSmoke_Draw, 1, (ObjectFunc) Effect_Effect340_Update,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_FIRE_SMOKE_3  */  {(void*) Effect_FireSmoke_Draw, 1, (ObjectFunc) Effect_Effect341_Update,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_SMOKE_1  */  {(void*) Effect_Effect342_Draw, 1, (ObjectFunc) Effect_Effect342_Update,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_SMOKE_2  */  {(void*) Effect_Effect343_Draw, 1, (ObjectFunc) Effect_Effect343_Update,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_EXPLOSION_MARK_1  */  {(void*) Effect_Effect344_Draw, 1, (ObjectFunc) Effect_Effect344_Update,             NULL,  -200.0f, -1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_LASER_MARK_1  */  {(void*) Effect_Effect345_Draw, 1, (ObjectFunc) Effect_Effect345_Update,             NULL,  -200.0f, -1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_346  */  {(void*) Effect_Effect346_Draw, 1, (ObjectFunc) Effect_Effect346_Update,             NULL,  -200.0f,  1, 0,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_347  */  {(void*) Effect_Effect347_Draw, 1, (ObjectFunc) Effect_Effect347_Update,             NULL,   100.0f,  1, 0, 40, 0,   0.0f,  0 },
  /* OBJ_EFFECT_348  */  {(void*) Effect_Effect348_Draw, 1, (ObjectFunc) Effect_Effect348_Update,             NULL,  -200.0f, -1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_349  */  {(void*)          NULL, 1, (ObjectFunc) Effect_Effect349_Update,             NULL,  -200.0f, -1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_350  */  {(void*)          NULL, 1, (ObjectFunc) Effect_Effect350_Update,             NULL,  -200.0f, -1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_351  */  {(void*) Effect_Effect351_Draw, 1, (ObjectFunc) Effect_Effect351_Update,             NULL,  -200.0f,  1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_CLOUDS  */  {(void*) Effect_Clouds_Draw, 1, (ObjectFunc) Effect_Clouds_Update,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_ENEMY_LASER_1  */  {(void*) Effect_Effect353_Draw, 1, (ObjectFunc) Effect_Effect353_354_Update,             NULL,   100.0f,  0, 0, 20, 0,   0.0f,  0 },
  /* OBJ_EFFECT_354  */  {(void*) SectorY_Effect354_Draw, 1, (ObjectFunc) Effect_Effect353_354_Update,             NULL,   100.0f,  0, 0, 20, 0,   0.0f,  0 },
  /* OBJ_EFFECT_355  */  {(void*) Effect_Effect355_Draw, 1, (ObjectFunc) Effect_Effect355_Update,             NULL,   100.0f,  1, 0, 20, 1,   0.0f,  0 },
  /* OBJ_EFFECT_356  */  {(void*) Effect_Effect356_Draw, 1, (ObjectFunc) Effect_Effect356_Update,             NULL,   100.0f,  1, 0, 20, 0,   0.0f,  0 },
  /* OBJ_EFFECT_357  */  {(void*) Effect_Effect357_Draw, 1, (ObjectFunc) Effect_Effect357_Update,             NULL,   100.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_KA_ENERGY_PARTICLES  */  {(void*) Katina_LaserEnergyParticlesDraw, 1, (ObjectFunc) Katina_LaserEnergyParticlesUpdate,             NULL,   100.0f,  1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_359  */  {(void*) Effect_Effect359_Draw, 1, (ObjectFunc) Effect_Effect359_Update,             NULL,  -100.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_360  */  {(void*) Effect_Effect360_361_362_Draw, 1, (ObjectFunc) Effect_Effect360_Update,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_361  */  {(void*) Effect_Effect360_361_362_Draw, 1, (ObjectFunc) Effect_Effect361_Update,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_362  */  {(void*) Effect_Effect360_361_362_Draw, 1, (ObjectFunc) Effect_Effect362_Update,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_363  */  {(void*) Aquas_Effect363_Draw, 1, (ObjectFunc) Aquas_Effect363_Update,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_364  */  {(void*) Effect_Effect364_Draw, 1, (ObjectFunc) Effect_Effect364_Update,             NULL,  -200.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_365  */  {(void*) Effect_Effect365_Draw, 1, (ObjectFunc) Effect_Effect365_Update,             NULL,  -200.0f,  1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_366  */  {(void*) Effect_Effect366_Draw, 1, (ObjectFunc) Aquas_Effect366_Update,             NULL,   100.0f,  1, 2,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_367  */  {(void*) Effect_Effect367_Draw, 1, (ObjectFunc) Effect_Effect367_Update,             NULL,  -200.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_368  */  {(void*) Titania_Effect368_Draw, 1, (ObjectFunc) Titania_Effect368_Update,             NULL,  -200.0f, -1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_369  */  {(void*) Meteo_Effect369_Draw, 1, (ObjectFunc) Meteo_Effect369_Update,             NULL,   100.0f,  0, 1, 40, 0,   0.0f,  0 },
  /* OBJ_EFFECT_370  */  {(void*) Meteo_Effect370_Draw, 1, (ObjectFunc) Meteo_Effect370_Update,             NULL,   100.0f,  0, 1, 40, 0,   0.0f,  0 },
  /* OBJ_EFFECT_371  */  {(void*) Meteo_Effect371_Draw, 1, (ObjectFunc) Meteo_Effect371_Update,             NULL,   100.0f,  0, 1, 40, 0,   0.0f,  0 },
  /* OBJ_EFFECT_372  */  {(void*) Effect_Effect372_Draw, 1, (ObjectFunc) Effect_Effect372_Update,             NULL,  -200.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_TIMED_SFX  */  {(void*)          NULL, 1, (ObjectFunc) Effect_TimedSfx_Update,             NULL,   500.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_374  */  {(void*) Effect_Effect374_Draw, 1, (ObjectFunc) Effect_Effect374_Update,             NULL,   100.0f,  0, 1, 40, 0,   0.0f,  0 },
  /* OBJ_EFFECT_375  */  {(void*) Effect_Effect375_Draw, 1, (ObjectFunc) Effect_Effect375_Update,             NULL,  -200.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_376  */  {(void*) Effect_Effect376_Draw, 1, (ObjectFunc) Effect_Effect376_Update,             NULL,  -200.0f,  1, 0,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_377  */  {(void*) Effect_Effect377_Draw, 1, (ObjectFunc) Effect_Effect377_Update,             NULL,   100.0f,  1, 0, 20, 0,   0.0f,  0 },
  /* OBJ_EFFECT_378  */  {(void*) Macbeth_Effect378_Draw, 1, (ObjectFunc) Macbeth_Effect378_Update,             NULL,   100.0f,  0, 0, 20, 0,   0.0f,  0 },
  /* OBJ_EFFECT_379  */  {(void*) Macbeth_Effect379_Draw, 1, (ObjectFunc) Macbeth_Effect379_Update,             NULL,   100.0f,  1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_380  */  {(void*) Macbeth_Effect380_Draw, 1, (ObjectFunc) Macbeth_Effect380_Update,             NULL,   100.0f,  0, 0, 20, 0,   0.0f,  0 },
  /* OBJ_EFFECT_381  */  {(void*) Effect_Effect382_Draw, 1, (ObjectFunc) Effect_Effect381_Update,             NULL,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_382  */  {(void*)          NULL, 1, (ObjectFunc) Effect_Effect382_Update,             NULL,   200.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_383  */  {(void*) Effect_Effect383_Draw, 1, (ObjectFunc) Effect_Effect383_Update,             NULL, 10000.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_384  */  {(void*) Effect_Effect384_Draw, 1, (ObjectFunc) Effect_Effect384_Update,             NULL,  -200.0f,  1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_385  */  {(void*) Effect_Effect385_Draw, 1, (ObjectFunc) Effect_Effect385_Update,             NULL,  -200.0f, -1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_386  */  {(void*)          NULL, 1, (ObjectFunc) Effect_Effect386_Update,             NULL,  -200.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_387  */  {(void*)          NULL, 1, (ObjectFunc) Effect_Effect387_Update,             NULL,  -200.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_388  */  {(void*) Effect_Effect388_Draw, 1, (ObjectFunc) Effect_Effect388_Update,             NULL,  -200.0f,  1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_389  */  {(void*) Effect_Effect389_Draw, 1, (ObjectFunc) Effect_Effect389_Update,             NULL,  -200.0f,  1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_390  */  {(void*)          NULL, 1, (ObjectFunc) Effect_Effect390_Update,             NULL,  -200.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_391  */  {(void*) Effect_Effect391_Draw, 1, (ObjectFunc) Effect_Effect391_Update,             NULL,   500.0f,  0, 0,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_392  */  {(void*) Solar_Effect392_Draw, 1, (ObjectFunc) Solar_Effect392_Update,             NULL,   300.0f,  1, 2, 10, 0,   0.0f,  0 },
  /* OBJ_EFFECT_393  */  {(void*) Effect_Effect393_Draw, 1, (ObjectFunc) Effect_Effect393_Update,             NULL,   300.0f,  1, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_394  */  {(void*) Effect_Effect394_Draw, 1, (ObjectFunc) Effect_Effect394_Update,             NULL,  -200.0f,  0, 1,  0, 0,   0.0f,  0 },
  /* OBJ_EFFECT_395  */  {(void*) Effect_Effect395_Draw, 1, (ObjectFunc) Effect_Effect395_Update,             NULL,   300.0f,  0, 1, 40, 0,   0.0f,  0 },
  /* OBJ_EFFECT_396  */  {(void*) Andross_Effect396_Draw, 1, (ObjectFunc) Andross_Effect396_Update,             NULL,  2000.0f,  0, 1, 40, 2,   0.0f,  0 },
  /* OBJ_EFFECT_397  */  {(void*) Bolse_Effect397_Draw, 1, (ObjectFunc) Bolse_Effect397_Update,             NULL,  2000.0f,  0, 1, 20, 0,   0.0f,  0 },
  /* OBJ_EFFECT_398  */  {(void*) Effect_Effect398_Draw, 1, (ObjectFunc) Effect_Effect398_Update,             NULL,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
  /* OBJ_EFFECT_399  */  {(void*) Effect_Effect399_Draw, 1, (ObjectFunc) Effect_Effect399_Update,             NULL,   100.0f,  0, 0, 40, 0,   0.0f,  0 },
};
// clang-format on
